//用户中心
numapp.factory('authService', ['$http', '$q', 'localStorageService', function ($http, $q, localStorageService,$location) {
    var serviceBase = allurl;
    var authServiceFactory = {};

    var _authentication = {
        isAuth: false,//是否登录
        userName: "",
        name: "",
        headPicture: ""
    };
    //注册
    var _saveRegistration = function (registration) {
        return $http.post(serviceBase + 'api/accounts/create', registration).success(function (response) {
            // if (loginData.useRefreshTokens) {//记住我
            //     localStorageService.set('authorizationData', { token: response.access_token, userName: loginData.userName, refreshToken: response.refresh_token, useRefreshTokens: true });
            // }
            // else {
                localStorageService.set('authorizationData', { token: response.response.tokeninfo.access_token, userName: registration.PhoneNumber, refreshToken: "", useRefreshTokens: false });
            // }
            return response;
        }).error(function(response){

        });
    };
    //修改信息
    var _saveUserinfo = function (Userinfo) {
        return $http.post(serviceBase + 'api/accounts/ChangeUserInfo', Userinfo).then(function (response) {
            return response;
        });
    };
    //重置密码
    var _resetPasswordUserinfo = function (Userinfo) {
        return $http.post(serviceBase + 'api/accounts/ResetPassword', Userinfo).then(function (response) {
            return response;
        });
    };
    //登录
    var _login = function (loginData) {

        var data = "grant_type=password&UserName=" + loginData.userName + "&Password=" + loginData.password;

        var deferred = $q.defer();

        $http.post(serviceBase + 'oauth/token', data, { headers: { 'Content-Type': 'application/x-www-form-urlencoded' } }).success(function (response) {

            if (loginData.useRefreshTokens) {//记住我
                localStorageService.set('authorizationData', { token: response.access_token, userName: loginData.userName, refreshToken: response.refresh_token, useRefreshTokens: true });
            }
            else {
                localStorageService.set('authorizationData', { token: response.access_token, userName: loginData.userName, refreshToken: "", useRefreshTokens: false });
            }
            //_authentication.isAuth = true;
            //_authentication.userName = loginData.userName;


            deferred.resolve(response);

        }).error(function (err, status) {
            deferred.reject(err);
            _logOut();
        });

        return deferred.promise;

    };

    //修改密码
    var _Change = function (ChangePassword) {
        var data = {
            "OldPassword": ChangePassword.OldPassword,
            "NewPassword": ChangePassword.NewPassword,
            "ConfirmPassword": ChangePassword.ConfirmPassword
        };
        var authData = localStorageService.get('authorizationData');

        return $http.post(serviceBase + 'api/accounts/ChangePassword', data, { headers: { 'Content-Type': 'application/json', 'Accept': 'application/json', 'Authorization': 'Bearer ' + authData.token } }).then(function (response) {
            return response;
        });
    };


    //注销
    var _logOut = function () {
        try {
            //清除数据
            var user = localStorageService.get('userinfo');
            localStorageService.remove('userinfo');
            localStorageService.remove('authorizationData');
            localStorageService.remove('backhistory');
            _authentication.isAuth = false;
            _authentication.userName = "";
            _authentication.name = "";
            _authentication.headPicture = "";
            $location.path('/content');
        } catch (e) {

        }
    };
    //进入网站看用户信息是否还在
    var _fillAuthData = function () {
        var authData = localStorageService.get('authorizationData');
        var user = localStorageService.get('userinfo');
        if (user && user.userinfo) {
            _authentication.isAuth = true;
            _authentication.userName = user.userinfo.userName;
            _authentication.name = user.userinfo.name;
            _authentication.headPicture = user.userinfo.headPicture;
            //获取用户信息
            var getUserinfo = function () {
                var useridUrl = allurl + "api/accounts/UserInfo";
                //请求用户信息
                $http.get(useridUrl).success(function (data) {
                    //保存用户信息
                    localStorageService.set('userinfo', { userinfo: data.response });

                    _authentication.isAuth = true;
                    _authentication.userName = user.userinfo.userName;
                    _authentication.name = user.userinfo.name;
                    _authentication.headPicture = user.userinfo.headPicture;
                     }).error(function () {
                    $location.path('/loginRegister/login');
                });
            };
            try {
                if (user.userinfo.userName && user.userinfo.name) {
                    getUserinfo();
                }
                else {
                    _logOut();
                }
            } catch (e) {
                _logOut();
            }

        } else {
            _logOut();
        }
    };
    //获取用户信息
    var _getUserinfo = function () {
        var useridUrl = allurl + "api/accounts/UserInfo";
        var deferred = $q.defer();
        //请求用户信息      , { params: { UserName: _authentication.userName } }
        $http.get(useridUrl).success(function (data) {
            //保存用户信息
            localStorageService.set('userinfo', { userinfo: data.response });
            deferred.resolve(data.response);
        }).error(function (err) {
            deferred.reject(err);
        });
        return deferred.promise;
    };
    authServiceFactory.saveUserinfo = _saveUserinfo;
    authServiceFactory.saveRegistration = _saveRegistration;
    authServiceFactory.resetPasswordUserinfo = _resetPasswordUserinfo;
    authServiceFactory.login = _login;
    authServiceFactory.logOut = _logOut;
    authServiceFactory.Change = _Change;
    authServiceFactory.fillAuthData = _fillAuthData;
    authServiceFactory.getUserinfo = _getUserinfo;
    authServiceFactory.authentication = _authentication;


    return authServiceFactory;

}]);
//拦截器
numapp.factory('authInterceptorService', ['$q','$injector', '$location','localStorageService', function ($q,$injector, $location, localStorageService) {

    var authInterceptorServiceFactory = {};
    //设置http request 默认请求的headers（添加Authorization）
    var _request = function (config) {
        config.headers = config.headers || {};

        var authData = localStorageService.get('authorizationData');
        if (authData) {
            config.headers.Authorization = 'Bearer ' + authData.token;
        }
        return config;
    };

    var _responseError = function (rejection) {
        if (rejection.config.url.indexOf(allurl) > -1) {
            if (rejection.status === 401) {//处理token过期
                var authService = $injector.get('authService');
                authService.logOut();
                $location.path('/loginRegister/login');
            }
            else if (rejection.status == 400) {//登录错误信息

            }
            else  {
                $('#errorTip').removeClass('hide');
                $('#home-wrap').hide();

            }
        }
        return $q.reject(rejection);
    };
    var _response = function (response) {
        if (response.config.url.indexOf(allurl) > -1) {
            if (response.data && response.data.status && response.data.status != '0') {
                $('#errorTip').removeClass('hide');
                $('#home-wrap').hide();
            }
        }
        else {//路由跳转、请求资源回到初始状态
            $('#errorTip').addClass('hide');
            $('#home-wrap').show();
        }
        return response;
    };
    authInterceptorServiceFactory.request = _request;
    authInterceptorServiceFactory.responseError = _responseError;
    //authInterceptorServiceFactory.response = _response;

    return authInterceptorServiceFactory;
}]);
//网站统计
numapp.factory('accessService', ['$http', '$q', 'localStorageService', function ($http, $q, localStorageService, $location) {
    var accessFactory = {};
    //板块添加统计
    var _addappnum = function (module, userName) {
        //添加点击量
        var url = allurl + 'api/comm/v1/post_access';
        return $http.post(url, { application: "数你行", module: module, ip_or_user: userName }, { headers: { 'Content-Type': 'application/json' } }).then(function (data) {
            return data.data;
        });
    };
    //网站跳转
    var _weblink = function (link) {
        if (app_paramas.inApp) {
            try{
                cordova.InAppBrowser.open(link, '_system', 'location=yes');
            } catch (e) {
                alert("请到浏览器打开："+link);
            }
        } else {
            window.location.href = link;
        }
    };
    accessFactory.weblink = _weblink;
    accessFactory.addappnum = _addappnum;
    return accessFactory;
}]);
//其他
numapp.factory('otherService', ['$http', '$q', 'localStorageService', function ($http, $q, localStorageService, $location) {
    var otherFactory = {};

    //返回位置
    var _top = 0;
    var _left = 0;
    var _getPosition = function () {
        return {
            top: _top,
            left: _left
        };
    };
    var _setPosition = function (top, left) {
        _top = top;
        _left = left;
    };
    //menu
    var _menutop = 0;
    var _menuleft = 0;
    var _getmenuPosition = function () {
        return {
            top: _menutop,
            left: _menuleft
        };
    };
    var _setmenuPosition = function (top, left) {
        _menutop = top;
        _menuleft = left;
    };
    otherFactory.getPosition = _getPosition;
    otherFactory.setPosition = _setPosition;

    otherFactory.getmenuPosition = _getmenuPosition;
    otherFactory.setmenuPosition = _setmenuPosition;
    return otherFactory;
}]);
