var numapp=angular.module("numapp",['ngCordova', 'ui.router', 'LocalStorageModule', 'angular-loading-bar']);
//api请求路径
var allurl = 'http://api.ttnzd.cn/20180301/';
//var allurl = 'http://192.168.188.100:8971/20180301/';

var haswechat = false;
//分享参数
var share_params = {
    title: '强烈推荐养生音乐',
    description: '养生音乐，听出好身体',
    imageUrl: 'http://admin.yunshi360.net/Upload/music/logo.png',
    basePath: 'http://www.ttnzd.cn/app_ysMusic/templates/app_index.html?isshared=true',                  // app中分享时的路径不能是本地，是basePath+location.hash
    shortcut_exclude_className: 'share_remove',         // 截图分享时，对class包含'share_removed'不截图
    share_QRcode_className: 'share_QRcode',
    share_QRcode_imagePath: '../img/share/share_QRcode.png'
};
//app参数
var app_paramas = {
    platform: 'android',
    apk_name: 'ysyy.apk',                                             //保存在本地时用的apk名
    app_version: '1.0.0',                                                 //当前app的版本
    checkupdate_params: { application: '养生音乐', platform: 'android', version: '1.0.0' },  //获取检查更新数据api使用的参数
    url_getversion: "http://api.ttnzd.cn/20170801/api/version/cfg/version_v1_7",        //获取检查更新api的地址
    clientID: '',
    apk_url: 'http://tool.ttnzd.cn/ysyy.apk', //
    inApp: true,       // 是否在手机app项目，在打包手机应用时，设为true
    share_allowed: true  //是否可以分享，该参数在run中重新设置了，当device ready后设为true
};
//配置路由
numapp.config(function($stateProvider,$urlRouterProvider){
    // //用于改变state时跳至顶部
    //$uiViewScrollProvider.useAnchorScroll();
    $urlRouterProvider.otherwise("/content");//错误的路由重定向到首页
    $urlRouterProvider.when("","/content");//默认进入先重定向
    $stateProvider
    //content
    .state("content",{
        url:"/content",
        templateUrl:"../templates/app_content.html",
        controller:"contentCtrl"
    })
    //功效
    .state("musicEffect",{
        url:"/musicEffect",
        templateUrl:"../templates/app_musicEffect.html",
        controller:"musicEffectCtrl"
    })
    //注册后完善信息
    .state("collectInfo",{
        url:"/collectInfo",
        templateUrl:"../templates/app_loginTest.html",
        controller:"collectInfoCtrl"
    })
    //我的日签
    .state("riqian",{
        url:"/riqian",
        templateUrl:"../templates/app_riqian.html",
        controller:"riqianCtrl"
    })
    //音乐播放
    .state("musicPlayer",{
        url:"/musicPlayer/{id:[A-Z_a-z0-9]*}/{index:[A-Z_a-z0-9]*}",
        templateUrl:"../templates/app_musicPlayer.html",
        controller:"musicPlayerCtrl",
        cache: false,
        reload: true
    })
    //音乐专辑列表
    .state("musicAlbum",{
        url:"/musicAlbum/{id:[A-Z_a-z0-9]*}",
        templateUrl:"../templates/app_musicAlbum.html",
        controller:"musicAlbumCtrl"
    })
    //登录注册
    .state('loginRegister',{
        url: "/loginRegister/{type:[A-Za-z]*}",
        templateUrl:'../templates/app_loginRegister.html',
        controller:'loginRegisterCtrl'
    })
    //忘记密码
    .state('ResetPassword',{
        url:'/ResetPassword',
        templateUrl:'../templates/app_ResetPassword.html',
        controller:'resetPasswordCtrl'
    })
    //个人中心
    .state('personalCenter',{
        url:'/personalCenter',
        templateUrl:'../templates/app_personalCenter.html',
        controller:'personalCenterCtrl'
    })
    //修改信息
    .state("app_updateUserinfo", {
        url: "/app_updateUserinfo",
        templateUrl: "../templates/app_updateUserinfo.html",
        controller: 'updateUserInfoCtrl'
    })
    //账户安全
    .state("appsecurity", {
        url: "/appsecurity",
        templateUrl: "../templates/app_appsecurity.html",
        controller: 'appsecurityCtrl'
    })
    //绑定第三方
    .state("bind_other", {
        url: "/bind_other",
        templateUrl: "../templates/app_bindOther.html",
        controller: 'bindOtherController'
    })
    //设置密保问题
    .state("setSecurity",{
        url:"/setSecurity",
        templateUrl:"../templates/app_setSecurity.html",
        controller:"setSecurityCtrl"
    })
});

//拦截器
numapp.config(function ($httpProvider) {
    $httpProvider.interceptors.push('authInterceptorService');
});

//启动Service服务
numapp.run(function ($timeout, $cordovaToast, $cordovaFileTransfer, $cordovaFileOpener2, authService, $rootScope, $state, $location, $stateParams, $http, localStorageService, accessService) {

    authService.fillAuthData();

    if (app_paramas.inApp) {
        app_toast = $cordovaToast;
    } else {
        app_toast = {};
        app_toast.showShortBottom = function (data) {
            alert(data);
        };
    }
    //显示更新确定框方法
    function showUpdateConfirm(data) {
        //app_toast.showShortBottom('更新的对话框');
        document.getElementById('updateData').innerHTML = data.response.template;
        $('#updateconfirm').modal('show');
        $('.modal-backdrop').addClass('modal-backdrop');
        document.getElementById('confirm').addEventListener('click', function () {
            //alert("confirm");
            $('#updateconfirm').modal('hide');
            //$ionicLoading.show({
            //    template: "已经下载：0%"
            //});
            //var progress = window.navigator.dialogsPlus.progressStart("下载", "拼命下载中....");
            //progress.setValue(100);
            if (app_paramas.platform == 'android') {
                // 安卓下载
                var progressbar = document.getElementById('progress');
                progressbar.value = 0;
                $('#progress').toggleClass('hide');
                //alert('targetPath');;
                var targetPath = cordova.file.externalApplicationStorageDirectory + app_paramas.apk_name;
                //alert('targetPathafter');
                //"file:///storage/sdcard/Download/taisui.apk"; //APP下载存放的路径，可以使用cordova file插件进行相关配置
                //app_toast.showShortBottom(targetPath);

                //app_toast.showShortBottom(JSON.stringify(data));
                var url = data.response.updateUrl; //可以从服务端获取更新APP的路径
                var trustHosts = true;
                var options = {};
                $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
                    // 打开下载下来的APP
                    $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive'
                    ).then(function (data) {

                        app_toast.showShortBottom('打开成功');
                        // 成功
                        navigator.app.exitApp();
                    }, function (err) {
                        app_toast.showShortBottom('打开错误');
                    });
                    $('#updateconfirm').modal('hide');
                    //$ionicLoading.hide();
                }, function (err) {
                    //alert(JSON.stringify(err));
                    app_toast.showShortBottom('下载失败');
                    $('#updateconfirm').modal('hide');
                    //alert('下载失败');
                }, function (progress) {
                    //进度，这里使用文字显示下载百分比
                    $timeout(function () {
                        var downloadProgress = (progress.loaded / progress.total) * 100;
                        //$ionicLoading.show({
                        //    template: "已经下载：" + Math.floor(downloadProgress) + "%"
                        //});
                        //progress.setValue(Math.floor(downloadProgress));
                        progressbar.value = Math.floor(downloadProgress);
                        if (downloadProgress > 99) {
                            $('#updateconfirm').modal('hide');
                            $('#progress').toggleClass('hide');
                        }
                    });
                });
            } else {
                // 苹果更新
                accessService.weblink(data.response.updateUrl);
            }
        }, false);
    }
    // 检查更新方法
    function checkUpdate() {
        var serverAppVersion = app_paramas.app_version; //从服务端获取最新版本
        //alert("before");
        //app_toast.showShortBottom(serverAppVersion);

        $http.get(app_paramas.url_getversion, { params: app_paramas.checkupdate_params }).success(function (data) {

            //alert('获取更新数据');
            //如果本地于服务端的APP版本不符合
            var S_vers = data.response.version.split(".");
            var server_v_id = S_vers[0] * 10000 + S_vers[1] * 100 + S_vers[2] * 1;
            var C_vers = app_paramas.app_version.split(".");
            var current_v_id = C_vers[0] * 10000 + C_vers[1] * 100 + C_vers[2] * 1;
            if (current_v_id >= server_v_id) {
                // 当前版本高于或等于服务器最新版本，不更新
                if (data.response.share_allowed && current_v_id == server_v_id) {
                    share_config = data.response.share_allowed;
                }
                //app_toast.showShortBottom('no update');
            } else {
                //app_toast.showShortBottom('update');
                showUpdateConfirm(data);
            }
        }).error(function (err) {
            app_toast.showShortBottom('获取更新数据失败');

            //alert('获取更新数据失败');
        });
    }

    // 处理android手机的返回键
    function onBackKeyDown(e) {
        if (location.href.indexOf("content") >= 0) {
            if ($rootScope.backButtonPressedOnceToExit) {
                navigator.app.exitApp();
            } else {
                $rootScope.backButtonPressedOnceToExit = true;
                app_toast.showShortBottom('忍心离开？再按一次退出');
                setTimeout(function () {
                    $rootScope.backButtonPressedOnceToExit = false;
                }, 1500);
            }
            e.preventDefault();
            return false;
        } else {
            history.back();
        }
        return true;
    }

    function onDeviceReady() {
        if (window.cordova && window.cordova.plugins.Keyboard) {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);

            // Don't remove this line unless you know what you are doing. It stops the viewport
            // from snapping when text inputs are focused. Ionic handles this internally for
            // a much nicer keyboard experience.
            // cordova.plugins.Keyboard.disableScroll(true);
        }
        Wechat.isInstalled(function (installed) {
            if (!installed) {
                haswechat = false;
                $rootScope.haswechat = haswechat;
            } else {
                haswechat = true;
                $rootScope.haswechat = haswechat;
            }
        });
        if (window.StatusBar) {
            StatusBar.styleDefault();
        }
        if (navigator && navigator.splashscreen) {
            navigator.splashscreen.hide();
        }
        //alert("ready");
        //navigator.splashscreen.hide();
        document.addEventListener("backbutton", onBackKeyDown, false);
        // 设置在app中的一些参数
        app_paramas.inApp = true;
        app_paramas.share_allowed = true;
        app_toast = $cordovaToast;
        //  ***极光推送 JPUSH 部分开始
        // try{
        //     window.plugins.jPushPlugin.init(); // 初始化
        //     var user = localStorageService.get('userinfo');
        //
        //     if (user) {
        //         var alias = user.userinfo.userName;
        //         //alert(alias);
        //         window.plugins.jPushPlugin.setAlias(alias);
        //         try{
        //             var tags = [ user.userinfo.gender,user.userinfo.blood,user.userinfo.zodiac,user.userinfo.constellation];
        //             window.plugins.jPushPlugin.setTags(tags);
        //         }catch(e){}
        //     } else {
        //         //alert('defined');
        //         window.plugins.jPushPlugin.setAlias('default');
        //     }
        //     window.plugins.jPushPlugin.setDebugMode(true); // 启动Debug模式，有log记录
        //     var onOpenNotification = function (event) {
        //         $location.path(event.extras.url);
        //         console.log("JPushPlugin:onOpenNotification is triggered");
        //     };
        //     var onReceiveNotification = function (event) {
        //         //$location.path(event.extras.url);
        //         try {
        //             var remindObj = [];
        //             if (localStorageService.get("TTNZD_ReminderList")) {
        //                 remindObj = localStorageService.get("TTNZD_ReminderList");
        //             }
        //             if (reminderPlugin) {
        //                 reminderPlugin.init(remindObj);
        //             }
        //         }catch(e){
        //
        //         }
        //     };
        //     document.addEventListener("jpush.openNotification", onOpenNotification, false);         // 注册监听打开通知事件
        //     document.addEventListener("jpush.receiveNotification", onReceiveNotification, false);   // 注册监听接收通知事件
        // }catch(ex){
        //
        // }
        //  ***极光推送 JPUSH 部分结束
        // 检查更新
        checkUpdate();
    }

    //alert("before deviceready");
    // 注册设备ready事件
    document.addEventListener("deviceready", onDeviceReady, false);

    //路由切换事件
    $rootScope.$on('$locationChangeSuccess', function (event, newUrl, currentUrl) {
        //微信登录是否安装
        $rootScope.haswechat = haswechat;
        
        // //判断导航的显示内容
        // if (newUrl.indexOf('content') < 0) {
        //     //内容页显示返回、分享按钮，不显示首页导航
        //     $('#nav_content').css({ 'display': 'block' });
        //     $('#nav_index').css({ 'display': 'none' });
        // }
        // else {
        //     //首页显示导航，不显示返回、分享按钮
        //     $('#nav_content').css({ 'display': 'none' });
        //     $('#nav_index').css({ 'display': 'block' });
        // }
        // //判断该页面是否能分享
        // if (app_paramas.share_allowed) {
        //     for (var i = 0; i < share_config.length; i++) {
        //         if (newUrl.indexOf(share_config[i].router) >= 0) {
        //             if(app_paramas.inApp){
        //                 $("#web-sharicon").css({ 'display': 'none' });//web网页版分享隐藏
        //                 $('#sharicon_content,#sharicon_content1').css({ 'display': 'block' });
        //                 $("#webshare_content,#webshare_content1").css({ 'display': 'none' });//web网页版首页分享隐藏
        //                 $('#sharicon').css({ 'visibility': 'visible' });
        //             }else{
        //                 $("#web-sharicon").css({ 'visibility': 'visible' });//web网页版分享隐藏
        //                 $('#sharicon_content,#sharicon_content1').css({ 'display': 'none' });
        //                 $("#webshare_content,#webshare_content1").css({ 'display': 'block' });//web网页版首页分享隐藏
        //                 $('#sharicon').css({ 'display': 'none' });
        //             }
        //
        //             if (share_config[i].share_type.indexOf('link') >= 0) {
        //                 $('#linkShare').css({ 'display': 'block' });
        //             }
        //             else {
        //                 $('#linkShare').css({ 'display': 'none' });
        //             }
        //             if (share_config[i].share_type.indexOf('shortcut') >= 0) {
        //                 $('#photoShare').css({ "display": "block" });
        //
        //             }
        //             else {
        //                 $('#photoShare').css({ 'display': 'none' });
        //             }
        //             break;
        //         }
        //         else {
        //             //分享按钮都不可见
        //             if(app_paramas.inApp){
        //                 $("#web-sharicon").css({ 'display': 'none' });//web网页版分享隐藏
        //                 $('#sharicon').css({ 'visibility': 'hidden' });
        //             }else{
        //                 $("#web-sharicon").css({ 'visibility': 'hidden' });//web网页版分享隐藏
        //                 $('#sharicon').css({ 'display': 'none' });
        //             }
        //         }
        //     }
        // }
        //网站访问统计
        var postaccess = function () {
            var url = allurl + 'api/webmaster/statistics/access';
            try {
                $http.post(url, { path: accessurl, agent: userAgentInfo, local_time: currentdate }, { headers: { 'Content-Type': 'application/json' } }).success(function (data) {
                    if (data.status == '-1') {
                        //alert('网络异常');
                    }
                }).error(function (err) {
                    //alert('网络异常');
                });
            } catch (e) {

            }
        };
        var accessurl = '';
        var userAgentInfo = '';
        var currentdate = "";
        try {
            accessurl = newUrl;
            userAgentInfo = navigator.userAgent;
            var date = new Date();
            currentdate = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate()
                + " " + date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
            //调用api
            postaccess();
        } catch (e) {

        }
    });
});

//定义滚动指令
numapp.directive('whenScrolled', function () {
    return function (scope, elm, attr) {
        // body窗口的滚动加载--需要Jquery
        $(window).scroll(function () {
            //滚动条距离顶部的距离
            var scrollTop = $(window).scrollTop();
            //滚动条的高度
            var scrollHeight = $(document).height();
            //窗口的高度
            var windowHeight = $(window).height();
            if (scrollTop + windowHeight >= scrollHeight) {
                scope.$apply(attr.whenScrolled);
            }
        });
    };
});

//返回HTML字符转换
numapp.filter('to_trusted', ['$sce', function ($sce) {
    return function (text) {
        return $sce.trustAsHtml(text);
    };
}]);
//ng-repeat 设置从下标为n开始循环
numapp.filter('startFrom', function() {
    return function(input, start) {
        if(input) {
            start = +start; //parse to int
            return input.slice(start);
        }
        return [];
    };
});

//页面渲染完成实现在render完成之后，执行Js脚本
numapp.directive('onFinishRenderFilters', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatFinished');
                });
            }
        }
    };
});

//确认密码验证directive
numapp.directive('pwCheck', [function () {
    return {
        require: 'ngModel',
        link: function (scope, elem, attrs, ctrl) {
            var firstPassword = '#' + attrs.pwCheck;
            elem.add(firstPassword).on('keyup', function () {
                scope.$apply(function () {
                    var v = elem.val() === $(firstPassword).val();
                    ctrl.$setValidity('pwmatch', v);
                });
            });
        }
    };
}]);
//在ng-bind-html下ng-click无效，用compile替换ng-bind-html
numapp.directive('compile', ['$compile', function ($compile) {
    return function(scope, element, attrs) {
        scope.$watch(
            function(scope) {
                return scope.$eval(attrs.compile);
            },
            function(value) {
                element.html(value);
                $compile(element.contents())(scope);
            }
        );
    };
}]);
var share_config = [
    { 'router': 'riqian', 'share_type': 'shortcut' },
];
